config/routes.rb
Rails.application.routes.draw do

  root 'car_rental#home'
  get 'sessions/new'
  get 'users/new'
  get '/help', to: 'car_rental#help'
  get '/about', to:'car_rental#about'
  get  '/signup',  to: 'users#new'
  post '/signup',  to: 'users#create'

  get  '/new_user',  to: 'users#newuser'
  post '/new_user',  to: 'users#createuser'

  get  '/new_admin',  to: 'users#newadmin'
  get  '/edit',  to: 'users#edit'
  post '/new_admin',  to: 'users#createadmin'

  get  '/new_superadmin',  to: 'users#newsuperadmin'
  post '/new_superadmin',  to: 'users#createsuperadmin'


  get  '/cars',  to: 'cars#index'
  post '/cars',  to: 'cars#create'

  get    '/login',   to: 'sessions#new'
  post   '/login',   to: 'sessions#create'
  delete '/logout',  to: 'sessions#destroy'
  get 'show_admin', to: 'users#show_admin', as: :show_admin, via: :all
  match '/users/newadmin', to: 'users#newadmin', as: :newadmin, via: :all

  get 'show_superadmin', to: 'users#show_superadmin', as: :show_superadmin, via: :all
  match '/users/newsuperadmin', to: 'users#newsuperadmin', as: :newsuperadmin, via: :all

  get '/bookings/:id/check_out', to: 'bookings#check_out', as: :check_out
  get '/bookings/:id/return', to: 'bookings#return', as: :return

  get 'email_notification/:id/:id1' => 'cars#email_notification' ,:as => 'email_notification'

  #match '/users/newuser', to: 'users#newuser', as: :new_user, via: :all
  resources :bookings
  #resources :users

  resources :users do
    resources :bookings
  end


  resources :cars do
    resources :bookings
  end

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  #root 'users#index'
end

app/models/car.rb
class Car < ApplicationRecord
  has_many :bookings
  validates :model, presence: true, length: { maximum: 30 }
  validates :description, presence: true, length: { maximum: 100 }
  validates :license_number, :presence => true
  validates :manufacturer, :presence => true
  validates :style, :presence => true, :inclusion => { :in => ['Hatchback', 'Sedan', 'SUV'] }
  validates :price, :presence => true
 # validates :status, :presence => true, :inclusion => { :in => [0, 1, 2] }
  validates :location, :presence => true

  def self.search(search, search_by)
    where("#{search_by} LIKE ?", "%#{search}%")
  end

  #def available?
  #  bookings.empty? || bookings.map(&:starting).min > Date.tomorrow
  #end

end

app/controllers/cars_controller.rb
class CarsController < ApplicationController
  before_action :set_car, only: [:show, :edit, :update, :destroy]
  before_action :logged_in_user, only: [:index, :edit, :update, :destroy]
  # GET /cars
  # GET /cars.json
  def index
    #@cars = Car.all
    @booking = Booking.where("user_id = ? AND status < 2", current_user.id)
    @options_for_search = Car.attribute_names.select {|c| c.include?('model') || c.include?('description') || c.include?('style') || c.include?('status') || c.include?('manufacturer')}
    if @booking.length > 0 then
      @cars = []
      respond_to do |format|
        format.html { redirect_to current_user,notice: 'You already have a booking. Please finish that 1st' }
      end
    elsif !params[:search].blank? and !params[:search_by].blank?
      @cars = Car.search(params[:search], params[:search_by])
    else
      @cars = Car.all
    end
  end

  def email_notification
    @car = Car.find(params[:id])
    @user = User.find(params[:id1])
    @car.update_attribute(:user, @user.email)
  end

  # GET /cars/1
  # GET /cars/1.json
  def show
    @car = Car.find(params[:id])
  end

  # GET /cars/new
  def new
    @car = Car.new
  end

  # GET /cars/1/edit
  def edit
    @car = Car.find(params[:id])
  end

  # POST /cars
  # POST /cars.json
  def create
    @car = Car.new(car_params)

    respond_to do |format|
      if @car.save
        format.html { redirect_to current_user, notice: 'Car was successfully created.' }
        format.json { render :show, status: :created, location: @car }
      else
        format.html { render :new }
        format.json { render json: @car.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /cars/1
  # PATCH/PUT /cars/1.json
  def update
    respond_to do |format|
      if @car.update(car_params)
        format.html { redirect_to @car, notice: 'Car was successfully updated.' }
        format.json { render :show, status: :ok, location: @car }
      else
        format.html { render :edit }
        format.json { render json: @car.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /cars/1
  # DELETE /cars/1.json
  def destroy
    @car.destroy
    respond_to do |format|
      format.html { redirect_to cars_url, notice: 'Car was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  def logged_in_user
    unless logged_in?
      store_location
      flash[:danger] = "Please log in."
      redirect_to login_url
    end
  end


  private
  # Use callbacks to share common setup or constraints between actions.
  def set_car
    @car = Car.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def car_params
    params.require(:car).permit(:model, :description, :license_number, :manufacturer, :style, :price, :location, :email_register)
  end

  def type(val)
    if(val==0)
      return 'Available'
    elsif(val==1)
      return 'Reserved'
    else
      return 'Checked Out'
    end
  end
  helper_method :type
end

app/helpers/cars_helper.rb
module CarsHelper
end

app/views/cars/_form.html.erb
<%= form_for(@car, html: { multipart: true }) do |f| %>
  <% if car.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(car.errors.count, "error") %> prohibited this car from being saved:</h2>

      <ul>
      <% car.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

    <div class="field">
      <%= f.label :model %><br>
      <%= f.text_field :model %>
    </div>
    <div class="field">
      <%= f.label :description %><br>
      <%= f.text_area :description %>
    </div>
    <div class="field">
      <%= f.label :license_number %><br>
      <%= f.text_field :license_number %>
    </div>
    <div class="field">
      <%= f.label :manufacturer %><br>
      <%= f.text_field :manufacturer %>
    </div>
    <div class="field">
      <%= f.label :style %><br>
      <%= f.select :style do %>
          <% ['Hatchback', 'Sedan', 'SUV'].each do |c| %>
              <%= content_tag(:option, c, value: c) %>
          <% end %>
      <% end %>
    </div>
    <div class="field">
      <%= f.label :price %><br>
      <%= f.text_field :price %>
    </div>
    <!--<div class="field">-->
    <!--<%= f.label :status %><br>-->
      <!--<%= f.select :status do %>-->
          <!--<% ["Available", "Checked Out", "Reserved"].each do |c| %>-->
              <!--<%= content_tag(:option, c, value: c) %>-->
          <!--<% end %>-->
      <!--<% end %>-->
    <!--</div>-->
    <div class="field">
      <%= f.label :location %><br>
      <%= f.text_field :location %>
    </div>
    <div class="actions">
      <%= f.submit %>
    </div>
<% end %>

app/views/cars/_search.html.erb
<%= form_tag(cars_path, :method => "get", id: "search-form") do %>
    Search by
    <%= select_tag 'search_by', options_for_select(@options_for_search)  %>
    <%= text_field_tag :search, params[:search], placeholder: 'Search' %>
    <%= submit_tag 'Search', :name => nil, class: 'btn btn-primary btn-md text-white' %>
<% end %>

app/views/cars/edit.html.erb
<h1>Editing Car</h1>

<%= render 'form', car: @car %>

<%= link_to 'Back', cars_path %>

app/views/cars/email_notification.html.erb
<h1>Email Notification Details</h1>
<%= link_to 'Show', @car %>
<%= link_to 'Back', cars_path %>

<%= form_for(@car) do |f| %>
    <% if @car.errors.any? %>
        <div id='error_explanation'>
          <h2><%= pluralize(@car.errors.count, 'error') %> prohibited this car from being saved:</h2>

          <ul>
            <% @car.errors.full_messages.each do |message| %>
                <li><%= message %></li>
            <% end %>
          </ul>

        </div>
    <% end %>

    <div class="field">
      <%= f.label :email_register %>
      <%= f.select 'email_register', options_for_select([['Yes', true], ['No', false]])%>
    </div>

    <div class="actions">
      <%= f.submit 'Register', class: 'btn btn-primary btn-md text-white' %>
    </div>

<%end%>

app/views/cars/index.html.erb
<div class="row">
  <div class="center jumbotron">
    <h1>Listing Cars</h1>
  </div>
</div>

<p id="notice"><%= notice %></p>
<%= render 'cars/search' %>
<% if @cars.blank? %>
    <h4>No Cars Available </h4>
    <h5><%=link_to 'Display All Cars',cars_path%> </h5><br/>
<% end %>
<table class="table">
  <thead>

  <div class="row">
    <div class="col-md-offset-10">
      <% if current_user.user_type.in?([0, 1]) %>
          <%= link_to 'New Car', new_car_path, :class => "btn btn-primary btn-md"%>
      <% end %>

    </div>

    <div class="col-md-12">
      <tr>
        <th>Model</th>
        <th>Description</th>
        <th>Manufacturer</th>
        <th>License Number</th>
        <th>Style</th>
        <th>Price</th>
        <th>Location</th>
        <% if current_user.user_type.in?([0, 1]) %>
            <th>Status</th>
        <%end%>

        <th></th>
        <th colspan="3"></th>
      </tr>

  <tbody>

  <% @cars.each do |car| %>
      <td><%= car.model %></td>
      <td><%= car.description %></td>
      <td><%= car.manufacturer %></td>
      <td><%= car.license_number %></td>
      <td><%= car.style %></td>
      <td><%= car.price %></td>
      <td><%= car.location %></td>
      <% if current_user.user_type.in?([0, 1]) %>
          <td><%= car.status %></td>
      <% end %>

      <td><%# type(car.status) %></td>
      <% if current_user.user_type.in?([0, 1]) %>
          <td><%= link_to 'All Bookings', car_bookings_path(car) %></td>

          <% if car.status == 'Checked Out'%>
              <td>Checked Out</td>
          <%else%>
              <td><%= link_to 'Edit car', edit_car_path(car) %></td>
              <td><%= link_to 'Delete car', car, method: :delete, data: { confirm: 'Are you sure?' } %></td>
              <td><%= link_to 'Book For a User', new_car_booking_path(car) %></td>
          <% end %>

        <% else %>
          <% if car.status == 'Checked Out'%>
              <td>Checked Out</td>
              <td><%= link_to 'Activate Email Notification', email_notification_path(car, current_user) %></td>
            <%else%>
              <td><%= link_to 'Book', new_car_booking_path(car) %></td>
          <% end %>
      <% end %>
      </tr>
  <% end %>

  </tbody>
</table>

<br>

<br><br>
<%= link_to 'Back to home page', current_user , {:style=>'color:green;', :class => "css_class"}%>


</div>
</div>

app/views/cars/new.html.erb
<h1>New Car</h1>

<%= render 'form', car: @car %>

<%= link_to 'Back', cars_path %>

app/views/cars/show.html.erb
<p id="notice"><%= notice %></p>

<%= link_to 'Back', cars_path %>